import {
  select,
  csv,
  scaleLinear,
  scaleTime,
  axisLeft,
  axisBottom,
  line
} from 'd3';

import { lineChart } from "./lineChart";
import { map } from "./map";

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

csv('data.csv')
  .then(data => {
  	let title = "Happiness Level"
  	let lastSelectedCountry = null;
    const countryClickCallback = country => {
      title = "Happiness Level of " + country;
      if (country == lastSelectedCountry) { country = null; }
      lastSelectedCountry = country;
      var filtered = [];
      if (country) {
        data.forEach(d => {
          if (d["Country"] == country) {
            filtered.push(d);
          }
        });
      }
      else {
        filtered = data;
        title = "Happiness Level";
      }
      lastSelectedYear = null;
      render(filtered, filtered);
    }
    
    let lastSelectedYear = null;
  	const yearSelectCallback = year => {
      title = "Happiness Level of " + year;
      if (year == lastSelectedYear) { year = null; }
      lastSelectedYear = year;
      var filtered = [];
      if (year) {
        data.forEach(d => {
          d.HappinessLevel = +d['HappinessLevel'];
      }
      lastSelectedCountry = null;
      render(data, filtered);
    };

    let lineGraph = lineChart(null, {svg, height: 1820, width, yLocation: 300, yearSelectCallback});
    const renderMap = map(null, {svg, height:350, width, yLocation: 0, countryClickCallback});
  
  	svg.append('text')
      .attr('class', 'title')
      .attr('transform', `translate(200,935)`)
      .text(title);

    const render = (lineData, mapData) => {
      svg.select('.title').text(title);
      lineGraph.render(lineData);
      renderMap(mapData, lastSelectedCountry);
    };
  	render(data, data);
});